Extremely slow Ajax/Javascript/CSS performance in Firefox 3 using non-free nvidia-glx-new

Bug #223238 reported by phinn on 2008-04-27
216
This bug affects 29 people
Affects Status Importance Assigned to Milestone
Mozilla Firefox
Confirmed
High
firefox (Ubuntu)
Undecided
Unassigned
linux-restricted-modules-2.6.24 (Ubuntu)
Undecided
Unassigned

Bug Description

Binary package hint: firefox-3.0

With Ubuntu 8.04

Firefox 3.0 has extremely slow Ajax/Javascript performance (I'm not sure exactly what). Probably CSS related.

#1 Gmail scrolls very slowly (compare this by switching gmail to HTML version at the bottom of inbox)

#2 Javascript images open/close/transition extremely slow
        examples:
             http://www.shacknews.com/ (images near the top of page, when transitioning, bring FF3.0 to its knees)
             http://www.worldofwarcraft.com/downloads/ssotd/#latest (images opening and switching to next one)
             http://www.transmissionbt.com/screenshots.php (opening and closing images are very choppy)

      There are many more, those are just a few.

I have both enabled and disabled Compiz but the problem is still there. I am not a web developer and can't pinpoint exactly what sort of code is causing the extreme slowness but I have tested it on multiple machines to make sure. I have compared it to my Windows XP dual boot box and the difference is night and day so it is definitely a Linux issue. Also on a Mac OS 10.4 machine its noticeably faster.

This bug: https://bugs.launchpad.net/bugs/217580
Is similar but only deals with Gmail, it is now known to be widespread issue. With performance this slow Firefox 3.0 beta should never have been the default browser. Unless its just the few machines I've used of course.

ProblemType: Bug
Architecture: i386
Date: Sun Apr 27 15:33:59 2008
DistroRelease: Ubuntu 8.04
NonfreeKernelModules: nvidia
Package: firefox-3.0 3.0~b5+nobinonly-0ubuntu3
PackageArchitecture: i386
ProcEnviron:
 PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
 LANG=en_US.UTF-8
 SHELL=/bin/bash
SourcePackage: firefox-3.0
Uname: Linux 2.6.24-16-generic i686

phinn (phinnvr6) wrote :
Vadim Peretokin (vperetokin) wrote :

Confirmed on 64bit Ubuntu too.

phinn (phinnvr6) wrote :

Another painful example: http://www.tuaw.com/

Scrolls extremely slow in Linux. If I keep that page open in another tab all my other pages are slower too.

phinn (phinnvr6) wrote :

To further pinpoint this is a Firefox 3.0b5 issue I downloaded Opera 9.5 beta 2 from http://www.opera.com/
filename is: opera_9.50b2-20080422.6-shared-qt_i386-en.deb

It's a night and day difference in the sites mentioned. It behaves around as fast as Firefox 3.0b5 does in Windows XP for me. If this was resolved in Firefox it would become web browser bliss.

phinn (phinnvr6) wrote :

Update:

I have now installed Ubuntu 8.04 on my laptop (Thinkpad T60 with 2GHz Core 2 Duo and ATI Mobility X1400 graphics). I am running the default install at this point. After checking the same websites the bug is NOT present.

The package is the same, so could this have something to do with the Athlon 64 3700+, or the NVIDIA GeForce 8600GT in my other box? It seems like it must be some kind of driver issue but I find that strange because the ATI in my T60 has always had poor performance, but not anymore.

Gmail still scrolls slower than usual on my laptop but all of the other sites mentioned it performs amazingly quick.

  • unnamed Edit (38 bytes, text/html; charset=ISO-8859-1)

I got an 8600GT too on my laptop.

Narrowing it down:

I did a clean install of Ubuntu 8.04 on my Athlon64/GeForce 8600GT main box. The performance issues are GONE. It's still not as fast as my Thinkpad T60 laptop but its close. The ONLY thing I did after this was install the NVIDIA drivers to get Compiz-Fusion working and when I rebooted and tested again the issue was BACK.

So it looks like this bug is directly between the Firefox 3.0b5 and the nvidia-glx-new drivers. Since Opera 9.5 beta is just as fast running these drivers its hard to say which is to blame. But one way or another that pinpoints the problem.

Driver: nvidia-glx-new
Version: 169.12+2.6.24.12-16.34

So for now no Compiz-fusion for me : ( I'll just have to wait to either a new NVIDIA driver or a new version of Firefox fixes it.

John Vivirito (gnomefreak) wrote :

Is anyone getting grey and almost frozen in firefox-3.0b5. this shoulds alot like bug #215728 Please find out if the problems they are seeing is the same for you as well.

Changed in firefox-3.0:
status: New → Incomplete
hkootstra (hkootstra) wrote :

my computer has the same problem, very slow , mail crawls along too

alxarch (alxarch) wrote :

The bug is in the human-murrine theme.
http://ubuntuforums.org/showthread.php?t=708928
if you change to another theme in gnome scrolling is not that slow.

CormacB (mashedpotatoman) wrote :

This is not an Intel graphics specific problem as suggested in the thread linked to by the previous comment as I am seeing it with an 8800 GTS both with and without Compiz.

The GUIMark benchmark at http://www.craftymind.com/factory/guimark/GUIMark_HTML4.html really illustrates this problem clearly. Under Windows XP I get 10 fps, but in Ubuntu 8.04 I get less than one frame per second.

phinn (phinnvr6) wrote :

With that benchmark I get about 1fps more on WinXP.

The performance issues with me have since been isolated to only when running the NVIDIA drivers. When I stick with the open source ones, I get worse performance for other stuff (like playing videos and what not) however Firefox runs it's best. There is definitely some issue between the NVIDIA drivers and Firefox 3.0 that still remains in RC1.

vanchuck (vanchuck) wrote :

I can confirm this on Kubuntu 8.04 64-bit. I have 2x nVidia 8600GT cards, using the closed drivers (installed via envy).

I'm not clear on how the themes work, but I'm guessing that KDE wouldn't be using the GNOME human-murrine theme, so I suspect that is not the issue for me anyway.

The above linked GUIMark benchmark gave me results of 20+fps on WindowsXP and ~0.25fps on Kubuntu.

This is a quad core system with 4gb ram and 3 disks in RAID5, so I can't see it being related to overall system performance. I have unfortunately never been able to get KDE to run without the closed 'nvidia' driver, so I can't give the benchmark results on the 'nv' driver.

On Wed, Jun 11, 2008 at 04:16:22PM -0000, vanchuck wrote:
> I can confirm this on Kubuntu 8.04 64-bit. I have 2x nVidia 8600GT
> cards, using the closed drivers (installed via envy).
>
> I'm not clear on how the themes work, but I'm guessing that KDE wouldn't
> be using the GNOME human-murrine theme, so I suspect that is not the
> issue for me anyway.
>
> The above linked GUIMark benchmark gave me results of 20+fps on
> WindowsXP and ~0.25fps on Kubuntu.
>
> This is a quad core system with 4gb ram and 3 disks in RAID5, so I can't
> see it being related to overall system performance. I have unfortunately
> never been able to get KDE to run without the closed 'nvidia' driver, so
> I can't give the benchmark results on the 'nv' driver.
>

its most likely the nvidia driver. ever tried our pristine nvidia
driver or the nv driver?

 status incomplete

 - Alexander

This problem STILL persists with Firefox 3.0 (final).

Any website that uses Ajax, or a lot of fancy effects runs very slow.

http://www.shacknews.com/ is a good example, whenever the image in the big box transitions to the next it slows the browser to a crawl.

This ONLY occurs for me with the NVIDIA drivers enabled. Therefor I have no Compiz-fusion, games, Google Earth, etc if I want to run Firefox 3.0

On Thu, Jun 19, 2008 at 01:01:35AM -0000, phinn wrote:
> This problem STILL persists with Firefox 3.0 (final).
>
> Any website that uses Ajax, or a lot of fancy effects runs very slow.
>
> http://www.shacknews.com/ is a good example, whenever the image in the
> big box transitions to the next it slows the browser to a crawl.
>
> This ONLY occurs for me with the NVIDIA drivers enabled. Therefor I have
> no Compiz-fusion, games, Google Earth, etc if I want to run Firefox 3.0
>

two main cases still cause issues:

 1. floating and absolute positioned div on the site
 2. a lot of css borders

 (3. some accelleratoin modes make tiled background cause CPU bustage)

anything of those you see on your sites?

 status incomplete

 - Alexander

I also notice that, the same machine and firefox 3 on XP is quite faster then on ubuntu 8.04

Rob Lanphier (robla) on 2008-07-07
description: updated
Rob Lanphier (robla) wrote :

I spent the better part of an afternoon fighting this problem (or one much like it) on my laptop. Free nv driver works, but the restricted driver causes really obnoxious stalls, to the point where the app dims out multiple times for several seconds on some pages.

Page which demonstrates the behavior most severely (ironically):
http://mozillalinks.org/wp/2008/02/firefox-3-ultimate-feature-performance/

I saved a local copy of the CSS, and did a binary search to find the offending CSS. Here it is:
#page {
 background: url(images/structure/backgroundColumns.png) repeat-y;
 background-position: 3px;
 margin-top: 50px;
 width: 970px;
 margin-left: auto;
 margin-right: auto;
 border: 1px solid #D9D9D9;
 z-index: 10;
 }

Readding pretty much anything on the #page entity causes rendering stalls. I started readding individual lines from this chunk, but there didn't seem to be one particular culprit. It seems that most/all of these lines contribute to the sluggishness somehow, to varying degrees.

Gustavo A. Díaz (gdiaz) wrote :

With the RC release of Firefox this problems was gonne... now with Final realse again i have this slow problem on scrolling... no matter if is nVidia or ATI restricted driver...

I think is more related to Firefox than a video driver... since like i said, in RC release was solved and the scrolling was fast.

On Mon, Jul 07, 2008 at 06:22:59AM -0000, Rob Lanphier wrote:
> I spent the better part of an afternoon fighting this problem (or one
> much like it) on my laptop. Free nv driver works, but the restricted
> driver causes really obnoxious stalls, to the point where the app dims
> out multiple times for several seconds on some pages.
>
> Page which demonstrates the behavior most severely (ironically):
> http://mozillalinks.org/wp/2008/02/firefox-3-ultimate-feature-performance/
>
> I saved a local copy of the CSS, and did a binary search to find the offending CSS. Here it is:
> #page {
> background: url(images/structure/backgroundColumns.png) repeat-y;
> background-position: 3px;
> margin-top: 50px;
> width: 970px;
> margin-left: auto;
> margin-right: auto;
> border: 1px solid #D9D9D9;
> z-index: 10;
> }
>
> Readding pretty much anything on the #page entity causes rendering
> stalls. I started readding individual lines from this chunk, but there
> didn't seem to be one particular culprit. It seems that most/all of
> these lines contribute to the sluggishness somehow, to varying degrees.
>

This is a background repeat issue (again) ... appears that nvidia xaa
implementation has its own share of issues with that.

Please attach your xorg.conf and your Xorg.0.log taken after
reproducing.

 - Alexander

mcneely.brandon (brandonblm) wrote :

I can also confirm this bug. I have Kubuntu 8.04 with Nvidia GeForce 6100 card. Please notify when this bug is fixed!

Brandon
McNeely

Alexander Sack (asac) wrote :

On Tue, Aug 05, 2008 at 02:01:04AM -0000, mcneely.brandon wrote:
> I can also confirm this bug. I have Kubuntu 8.04 with Nvidia GeForce
> 6100 card. Please notify when this bug is fixed!

If you are using the nonfree (nvidia) driver, please see if the free
(nv) driver works better for this particular use-case.

 - Alexander

It's not firefox, my computer does it even with an audio disc playing
sometimes.

On Tue, 2008-08-12 at 15:17 +0000, Alexander Sack wrote:

> On Tue, Aug 05, 2008 at 02:01:04AM -0000, mcneely.brandon wrote:
> > I can also confirm this bug. I have Kubuntu 8.04 with Nvidia GeForce
> > 6100 card. Please notify when this bug is fixed!
>
> If you are using the nonfree (nvidia) driver, please see if the free
> (nv) driver works better for this particular use-case.
>
>
> - Alexander
>

On Wed, Aug 13, 2008 at 12:55:23AM -0000, hkootstra wrote:
> It's not firefox, my computer does it even with an audio disc playing
> sometimes.

So, did you try the free driver?

>
> On Tue, 2008-08-12 at 15:17 +0000, Alexander Sack wrote:
>
> > On Tue, Aug 05, 2008 at 02:01:04AM -0000, mcneely.brandon wrote:
> > > I can also confirm this bug. I have Kubuntu 8.04 with Nvidia GeForce
> > > 6100 card. Please notify when this bug is fixed!
> >
> > If you are using the nonfree (nvidia) driver, please see if the free
> > (nv) driver works better for this particular use-case.
> >
> >
> > - Alexander
> >
>

 - Alexander

phinn (phinnvr6) wrote :

Personally (as I stated above) the free driver (nv) is much faster with Firefox 3.0 than the nvidia one. That means, of course, no compiz-fusion or any gaming.

Also, Opera 9.5 runs totally fine with the nvidia driver and nv driver. So it has to be something with nvidia-glx and Firefox 3.0

Alexander Sack (asac) wrote :

On Wed, Aug 13, 2008 at 05:25:58PM -0000, phinn wrote:
> Personally (as I stated above) the free driver (nv) is much faster with
> Firefox 3.0 than the nvidia one. That means, of course, no compiz-fusion
> or any gaming.
>
> Also, Opera 9.5 runs totally fine with the nvidia driver and nv driver.
> So it has to be something with nvidia-glx and Firefox 3.0
>

firefox 3 now makes heavy use of X for rendering things. (through
cairo). Thats the main reason, why firefox now gets slower when
drivers are of low quality.

 - Alexander

I can also confirm this, I'm using latest restricted nvidia 177.67 driver. I see this as firefox bug bacause opera runs smoothly, and also there is that annoyance with sqlite and IO, in my opinion, Mozilla doesn't care much about linux users :-/

mingz (mingz-au) wrote :

I confirm this bug.

The problems can be relieved by:
1. change your theme. Human series theme is a big problem.
2. change the driver of your video card from proprietary ones to free ones.

Hope this helps. ;)

mingz (mingz-au) wrote :

Add some words to the above post.

The clearlook theme seems to work pretty well with ff3.

bro (matthijsbro) wrote :

I can confirm the bug too. But I cannot reasonably ascribe to Nvidia. Opera works, as does Firefox and IE7 under windows in a virtual machine. Blaming it on the first thing proprietary seems a bit dull to me.

For what it's worth, KDE 4 has major issues with it too. While it could be
some functions that they used were buggy, it's still a bug in nvidia, since
the stuff works fine on ati cards.

OffHand (offhand303) wrote :

I have the same problem here. Firefox 2 on Linux and AJAX is fine. Firefox 3 on XP/OS X and AJAX is fine. With Firefox 3 on Linux and AJAX the performance is horrible. Almost unusable. Try to browse a few http://www.hyves.nl profiles and you will see what I mean. It's a Dutch website but understanding the content of the profiles does not matter.

bro (matthijsbro) wrote :

Sorry but I really resist the logic from Vadim Peretokin and others that the
bug is nvidia's because it works well with ati. If a site works well in IE
is it a bug in firefox if it doesn't work there?

Surely something might need improvement in Nvidia's drivers. But lots and
lots of people have these cards and if there's a browser that performs bad
with lots and lots of people that just means there is something you need to
fix. That's not open source versus proprietary, but open source versus buggy
reality.

Vadim Peretokin (vperetokin) wrote :

A) Firefox shouldn't be using buggy nvidia functions

B) Those nvidia functions are buggy.

Yes, firefox can fix it, but they aren't, so what can you do? Switch to
another browser if you want or something.

It's not Firefox, I have it without any browser running. I have to Turn
the computer off and then back on and everything works fine then.

Harm kootstra

On Mon, 2008-09-08 at 16:05 +0000, Vadim Peretokin wrote:

> A) Firefox shouldn't be using buggy nvidia functions
>
> B) Those nvidia functions are buggy.
>
> Yes, firefox can fix it, but they aren't, so what can you do? Switch to
> another browser if you want or something.
>

OffHand (offhand303) wrote :

If that is the case with you hkootstra, I think that you are experiencing a different bug. What has been discussed here definitely has to do with AJAX and the Cairo engine (which FF3 and Epiphany are using).

mattg86 (gara-matt) wrote :

So has any progress been made with this bug? Because I seem to be having this issue and its not been improved. Running ubuntu 8.04, FF 3.0.1, NVidia GeForce 8600MT (laptop) Nvidia non-free driver 169.12.

bro (matthijsbro) wrote :

You can read interesting things that might help you here: http://www.nvnews.net/vbulletin/showthread.php?t=118088
You are using driver version 169, I'd advice to at least install a later driver via envyng.
For me the command mentioned in above thread made everything very workable:
"~$ nvidia-settings -a InitialPixmapPlacement=2"

mattg86 (gara-matt) wrote :

bro:

I've tried what you suggested and it seems to have little effect. I still experience severe usability issues with many websites, such as the one Rob Lanphier mentioned:

http://mozillalinks.org/wp/2008/02/firefox-3-ultimate-feature-performance/

The issue has become slightly better since installing the new version. I've noticed that before installing the new driver my entire firefox would hang when visiting the above website and the only way to get out would be to kill firefox. With the new drivers I notice that I can close the tab and therefore salvage firefox (whereas I could not do this before.) The website is still completely unusable.

An example of a website that runs painfully slow that I like to visit a lot is facebook.com This is unfortunate. Any new progress on this bug?

mattg86 (gara-matt) wrote :

bro:

Sorry, I just realized I have to add the nvidia-settings command to my gnomerc >< it works though! thanks for the pointer. Ignore my previous post complaining.

Thanks =)

cgabbadon (cgabbadon) wrote :

Have the same exact issue here. I have an nVidia card on my laptop - I have ultra slow JavaScript/AJAX performance in Firefox and Epiphany. The library I mainly use for development purposes is jQuery.

I just downloaded and installed the latest version of Opera, and the JavaScript performance is perfect - no delays/slowness at all. Likewise, I have Windows XP running as a virtual instance through VirtualBox and the performance is fine in Firefox and Google Chrome (I didn't test anything else there).

I notice the performance problem is biggest in two situations:
1. When JavaScript DOM manipulation is taking place in HTML elements that are nested pretty deep: When I have the same script running on a top level element vs. a deeply nested one, the performance in the deeply nested one is a lot worst.
2. Generally, when working with pretty complex pages. For example, dragging/dropping elements with a lot of nested elements inside the draggable container.

Any updates on this issue?

Svetlozar Argirov (zaro) wrote :

I can also confirm this. Most of the Ajax sites with animations are terribly slow.

Using nvidia driver 177.80 & Firefox 3.0.3 from Ibex .

Svetlozar Argirov (zaro) wrote :

 "~$ nvidia-settings -a InitialPixmapPlacement=2" worked for me.

10x bro.

JPHein (jp-jphein) wrote :

From much mucking about, I have decided that to fully reproduce this bug requires the below.

Ubuntu 8.04.1 2.6.24-21 64-bit
nvidia-glx-new 169.12
With Xinerama enabled in xorg.conf.

All programs run sluggish including:
Firefox Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9.0.3) Gecko/2008092510 Ubuntu/8.04 (hardy) Firefox/3.0.3

My cards are 8800GT and 8500GT with 4 monitors.
Perhaps mismatched cards are the culprit. They seem to run fine in Windows Vista (64-bit)

The fix above definitely sped some parts of the gui up, but slowed all the javascript way down. To the point where I couldn't move the cursor to another monitor for several seconds.

I can post more configuration files and whatnot if anyone is interested.

JPHein (jp-jphein) wrote :

The solution seems to be:
nvidia-settings -a InitialPixmapPlacement=2

Then install and use Opera.

Lemmiwinks (lemmiwinks) wrote :

I can absolutely confirm this bug!

Using Ubuntu 8.10 64bit
nvidia-glx-new 177.80
Firefox 3.03

Got a Core 2 Duo 1800Mhz + Geforce 8600M GT, so plenty of power to display webpages with javascript/ajax/css content...

"~$ nvidia-settings -a InitialPixmapPlacement=2" worked only for a few pages like studivz.net

But today, youtube included a new toolbar on their page, down at the bottom, which makes the whole site running terribly slow! As there are such extremely frequented webpages affected, I think a final solution to this problem really HAS to be found now.

JPHein (jp-jphein) wrote :

I don't understand why this status is incomplete.
Anyway, performance degrades when using Opera with some javascript too. i.e. grandcentral.com.

Firefox and Opera both exhibit the behavior, just on different sites. I really think this is a driver thing.

Changed in firefox-3.0:
status: Incomplete → Confirmed
talent03 (talent03) wrote :

I have this problem as well with nvidia-glx-new 177.80. The command shown in this thread does not change a thing. I don't have any add-ons. I notice the sluggishness quite a bit when scrolling in slashdot.org articles. It definitely is affected with javascript. I have noticed this on other computers without nvidia. It is definitely slower than on windows, even compared to windows in a VM. I hope this is fixed, because I get so annoyed I just run opera many times.

cruiseoveride (cruiseoveride) wrote :

Another slow example:

http://www.tomshardware.com/us/

You only know how slow Firefox is when you try out the same page in Opera

Simon Porter (portersb) wrote :

Still have this issue with 9.04; using Firefox 3.0.9 and nvidia drivers 173...

Vadim Peretokin (vperetokin) wrote :

I believe 180 series are the recommended ones in 9.04. They have a lot of
improvements.

Gustavo A. Díaz (gdiaz) wrote :

Indeed with 180 family drivers, this continues being so slow... A clear
example, with Gmail.

2009/4/26 Vadim Peretokin <email address hidden>

> I believe 180 series are the recommended ones in 9.04. They have a lot of
> improvements.
>
> --
> Extremely slow Ajax/Javascript/CSS performance in Firefox 3 using non-free
> nvidia-glx-new
> https://bugs.launchpad.net/bugs/223238
> You received this bug notification because you are a direct subscriber
> of the bug.
>

--
Gustavo A. Díaz
GDNet Projects
www.gdnet.com.ar

bro (matthijsbro) wrote :

I just installed jaunty on an xps 1330 with nvidia 180 drivers and I have no
problem whatsoever without any tricks. I didn't have any since I solved the
problem with the "~$ nvidia-settings -a InitialPixmapPlacement=2" trick.

_________________________________
http://schijnoplosser.nl
http://broncode.net
skype: matthijsbro
t +31 (0)6 17 444 524 (mob)

On Sun, Apr 26, 2009 at 8:08 PM, Gustavo A. Díaz <email address hidden>wrote:

> Indeed with 180 family drivers, this continues being so slow... A clear
> example, with Gmail.
>
> 2009/4/26 Vadim Peretokin <email address hidden>
>
> > I believe 180 series are the recommended ones in 9.04. They have a lot of
> > improvements.
> >
> > --
> > Extremely slow Ajax/Javascript/CSS performance in Firefox 3 using
> non-free
> > nvidia-glx-new
> > https://bugs.launchpad.net/bugs/223238
> > You received this bug notification because you are a direct subscriber
> > of the bug.
> >
>
>
> --
> Gustavo A. Díaz
> GDNet Projects
> www.gdnet.com.ar
>
> --
> Extremely slow Ajax/Javascript/CSS performance in Firefox 3 using non-free
> nvidia-glx-new
> https://bugs.launchpad.net/bugs/223238
> You received this bug notification because you are a direct subscriber
> of the bug.
>

phinn (phinnvr6) wrote :

Unfortunately the "nvidia-settings -a InitialPixmapPlacement=2" hack didn't do much if anything at all for me. This is a huge Firefox bug and almost all NVIDIA Series 180 driver users encounter.

Some notable bad offenders are:
www.shacknews.com (when the javascript image changes at the top the whole browser freezes)
www.slashdot.org (with the new ajax engine that loads more of the page down the button its just terrible)

It seems to be a javascript/Ajax bug in Firefox 3.x.

Ubuntu Linux is a wonderful distro but unfortunately I only use Windows XP on my main box because literately of this bug alone. Firefox being open is 90% of what I use and it's performance compared to Windows is deplorable with these drivers.

Hopefully either Firefox 3.5, or something from Nvidia, or whatever will eventually have a real fix. Opera runs great in Linux but I don't want to switch browsers just because of a bug no one can/will fix.

phinn (phinnvr6) wrote :

Unfortunately there is more bad news. I installed Firefox 3.5 beta 4 in Ubuntu 9.04 running the newest Nvidia drivers and the bug is *not fixed*.

User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.1b4) Gecko/20090423 Firefox/3.5b4
Build Identifier: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.1b4) Gecko/20090423 Firefox/3.5b4

Running: Ubuntu 8.10 & 9.04, NVIDIA GeForce 8600GT, and NVIDIA 180 series (newest) graphics drivers. Also running Compiz-fusion built into Ubuntu.

Problem: Lots of websites that seem to use Javascript/Ajax heavy scripts run VERY slow with NVIDIA drivers. This appears to be a Firefox issue because I can run Opera, WebKit based browsers, etc and there is NO issue in Linux. Only Firefox.

Example websites:
http://www.shacknews.com (during the main image transition to a new one the browser slows to a crawl and wont even scroll)
http://www.slashdot.org (when scrolling to button the new ajax page reload slows browser down)

Tons of websites have this problem with the Firefox 3.0/3.5 + NVIDIA drivers. Those are just 2 test sites.

I have tried a hack suggested on Ubuntu's bug page(with same bug):
nvidia-settings -a InitialPixmapPlacement=2
But it really does nothing.

There is a long running bug page on Ubuntu's website that could be helpful to devs:
https://bugs.launchpad.net/bugs/223238

Please Help!

Reproducible: Always

Steps to Reproduce:
1. Run Linux with newest NVIDIA 180 drivers
2. Run Compiz-fusion
3. Run Firefox 3.0 or 3.5 with any of the websites listed
Actual Results:
SLOOOOW performance. Seems to be javascript/AJAX related.

Expected Results:
Normal fast performance as seen with other web browsers.

works for me - Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0.9) Gecko/2009042113 Ubuntu/9.04 (jaunty) Firefox/3.0.9

Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.1b5pre) Gecko/20090428 Shiretoko/3.5b5pre

I have a nearly identical setup 8600gt, nvidia 180 driver, Compiz-fusion. The given example pages load reasonably fast given their size .5s or so. Similar performance on Windows and other browsers.

It's not a matter of the load times. It's a matter of the javascript running while the pages are loaded. For example (as stated) on the Shacknews example during the transitions of images in the "Top Stories" area slow the web browser to a crawl if you try to scroll during them.

Also on Slashdot where you goto the bottom of the page during its reload (where it loads more of the website) it loads very slow. MUCH slower than Windows. There are many other websites that have issues too on the Ubuntu bug page for the same issue here: https://bugs.launchpad.net/bugs/223238

I don't see any issue on Slashdot when using their continuous page besides the obvious reflowing of the document as content gets added. Shacknews has a slight hitch when the transition is animating but nothing severe. When I get a chance I'll enable the nv driver and see if there is any difference.

Filip Sufitchi (fsufitch) wrote :

Also affects me on Firefox 3.0, Ubuntu 9.10, with a GeForce 8400M GS graphics card using the 180 driver. The "nvidia-settings -a InitialPixmapPlacement=2" fixed the slowdown in Facebook and a few other sites.

See also bug 431113. This one seems to have more information, though.

roc, vlad, any idea what might be up here?

Ok, the linked page mentions that apparently the nvidia drivers in question have some xaa bugs in background tiling...

phinn, can you possibly manage to reduce a web page that's slow for you? Is the issue, as in the ubuntu bug report, some background image?

It seems to me that these are Xrender issues.

The only thing I'm not sure of is why Webkit-GTK2 based browsers (which use cairo I think) aren't hitting them. Is Webkit-GTK2 using cairo image surfaces for its backbuffer or something?

It's not clear to me that anyone in that thread tried webkit-gtk2... They tried opera, but I see no mention of webkit-based browsers. Did I miss it?

Comment #0 says the reporter did.

Ah, indeed.

(In reply to comment #6)
> It seems to me that these are Xrender issues.
>
> The only thing I'm not sure of is why Webkit-GTK2 based browsers (which use
> cairo I think) aren't hitting them. Is Webkit-GTK2 using cairo image surfaces
> for its backbuffer or something?

They may be, and we may want to as well if we can get SHM pieces in place and get rid of all the child widgets. Then we'd just have one surface to render to and would control our speed; we'd lose a bit of speed for things like text on some drivers, but we'd get direct control over all of our rendering.

Dan Quade (danquade) wrote :

I don't understand why everyone thinks this is a Firefox 3 bug. It's happened to me on FF2.0 too. In fact, it was even worse with Firefox 2.

Sylfurd (renaud-delcoigne) wrote :

I confirm these really bad javascript performances with nvidia drivers and Firefox (3.0 & 3.5). It's really problematic for a website dev. And I got a Quad Core CPU (but a really cheap 8400GS Nvidia card).

Peacekeeper, the Futuremark Javascript benchmark runs atrocely bad and can't even finish. ( http://service.futuremark.com/peacekeeper/run.action )

What is *fun* is that it (Peacekeeper & JS in general) runs A LOT better when running firefox 2.0 in a virtualbox with Windows ...

I'm really hoping for a solution, but I don't think there will be one soon since this issue seems to be old ...

Sylfurd (renaud-delcoigne) wrote :

Problem solved with the last stable version of the Nvidia drivers (185.18.14) !

I think it needs to be confirmed by other users yet !

Dan Quade (danquade) wrote :

No it's not solved. (185.18.14)

Bryce Harrington (bryce) on 2009-09-02
tags: added: hardy

Summary : "worksforme"

Hello,

Hardware : Asus X77VN laptop using GeForce GT 240M
Platform : Ubuntu 9.10 (karmic) 64-bit, Firefox 3.5.7
Result : no slowdown observed. All examples tested are snappy :
             http://www.shacknews.com/
             http://www.worldofwarcraft.com/downloads/ssotd/#latest
             http://www.transmissionbt.com/screenshots.php (404 not found)
             http://www.tuaw.com/

Firefox ID : Mozilla/5.0 (X11; U; Linux x86_64; fr; rv:1.9.1.7) Gecko/20100106 Ubuntu/9.10 (karmic) Firefox/3.5.7

Regards

phinn, possible for you to do the reduced testcase mentioned in comment 5? Or is that information provided in the other bug?

Richard Laager (rlaager) wrote :

This happens for me on Launchpad bugs. Running top shows Xorg as pegging the CPU for several seconds. I haven't noticed it on anything but Launchpad. I'm running Lucid.

Damien Lecan (dlecan) wrote :

On Lucid, with Firefox 3.6.3:
Scrolling launchpad's bugs is very slow, especially when list of subscribers is visible.

It happens either with free nvidia video card drivers or with proprietary drivers.

Firefox : Mozilla/5.0 (X11; U; Linux i686; fr; rv:1.9.2.3) Gecko/20100423 Ubuntu/10.04 (lucid) Firefox/3.6.3

lunch (launch-mailinator-com) wrote :

This is from this bug (which was unfairly closed): https://bugs.launchpad.net/launchpad-foundations/+bug/575254/comments/2

This is extremely embarrassing for Canonical. This is one of their showpiece products and it fails to work well on their own platform. I accessed Launchpad from a Windows machine using Firefox 3.6 and it works a lot better than an Ubuntu machine. I would mark this as "critical" importance because if the general media is aware of this bug then it is going to be a scandal for Canonical.

angelous (angelous) wrote :

weir, fix for two weeks after i install 10.04 then i update and slow internet again

Beowulf (s-highlander) wrote :

I was experiencing slow firefox 3.6 which heavily loaded CPU for months. I have solved this problem by building firefox from sources.

Beowulf (s-highlander) wrote :

So the new firefox which I build from sources apparently renders many times faster, normally it consumes 4 % of CPU time ( it used to be 50% -100% with firefox 3.6 from lucid binary package.

I was using CFLAGS="-march=core2 -O2 -pipe"

Sebastian Meyer (wastl) wrote :

This bug is extremely disappointing and annoying. Running a fresh up-to-date Lucid 10.04.1 install, discovering a bug, willing to report that bug, but being hindered by such desperate slow performance of Launchpad in Ubuntu's default web browser Firefox (3.6.10)!
I just installed Opera to write this comment and it "operates" as fast as usual.

PS: I have a nvidia card installed using the proprietary drivers and normal compiz effects enabled.

Sebastian Meyer (wastl) wrote :

I'd like to add that, for me, the "slow motion mode" of Launchpad while viewing the list of subscribers is not a problem when deactivating proprietary drivers. Using the nouveau driver instead of nvidia-current (195.36.24-0ubuntu1~10.04), Firefox runs smoothly in Launchpad.

Alistair Buxton (a-j-buxton) wrote :

My observations (using firefox 3.6.13 and nvidia 260.19.06)

- The problem only happens on launchpad.net. None of the other examples given on this bug still exhibit the problem. Likely they were all caused by the old slow javascript engine that was replaced in a version of FF since 3.0. But the launchpad problem is different because:
- The problem still happens even when javascript is disabled, but it does not happen if you save the HTML of a launchpad bug and load that.
- The problem gets worse as the firefox window becomes larger. This would seem to imply something is causing too many fullscreen repaints.

Alistair Buxton (a-j-buxton) wrote :

As a test I tried the firefox versions in ppa:ubuntu-mozilla-daily/ppa.

I now have "namoroka 3.6.14pre" and "minefield 4.0b9pre" and they are both *much* faster than the standard maverick firefox when browsing launchpad.

Alistair Buxton (a-j-buxton) wrote :

Please ignore previous comment - it turns out that those versions are equally affected, including firefox 4.0 beta. And it seems the problem is made much worse when the graphics card is under load from some other application doing 3D stuff...

Changed in firefox:
importance: Unknown → High
status: Unknown → Confirmed
Øyvind Stegard (oyvinst) wrote :

See this thread at nvnews:
http://www.nvnews.net/vbulletin/showthread.php?t=152295 [launchpad.net bug views excruciatingly slow]

particularly this official reply from nvidia:
http://www.nvnews.net/vbulletin/showpost.php?p=2287025&postcount=7

.. in which AaronP states: "Thanks for reporting this. I took a look today, and it appears that Firefox is using an enormous pixmap that exceeds the GPU's maximum rendering dimensions, causing software fallbacks. While we will attempt to make it as fast as possible, performance would be greatly improved if Firefox would render using surfaces that fit within the maximum renderable dimensions."

The bad launchpad.net performance in Firefox is bloody annoying, no matter who is to blame. It does not help that launchpad.net itself is a very slow website with high load-times per page view. Makes for a sluggish impression in total..

Dan Quade (danquade) wrote :

That's interesting. I wonder why this issue does not exist on Windows using the same Firefox and the same nVidia driver.

Jacopo Moronato (jmoronat) wrote :

It does not happen on Windows.

dfszb (dnotob) wrote :

On the same computer (running Xubuntu 10.10 ), open this page in both Google Chromium and Firefox 4.0.
Then hit 'end', then hit 'home'. In Chromium, the movement is very fast, firefox needs ~0.5 second to go to the end.
So it is the same computer, it is the same (nvidia proprietary) driver, it is the same (2.6.38) kernel. It is clearly a firefox issue.

dfszb (dnotob) wrote :

just a small note, firefox 4.0 seems to be much better than previous firefox versions, just that it is still much slower than chromium.

rdb (rdb) wrote :

Same issue on FreeBSD amd64, using firefox 3.6.13 and nvidia drivers. Especially launchpad.net brings the system to a crawl ('top' reports Xorg and firefox-bin using up almost all of my two CPUs as I'm writing this).

Cas (calumlind) wrote :

Please be aware that there is a separate LP Bug #605567 that deals with Launchpad.net causing Firefox to slow down.

Whether at the technical level it is the same I am not sure however the examples at the top of this bug all work fine for me so I consider a separate bug necessary for the Launchpad.net issue to avoid confusion.

Thank you for reporting this issue about a driver from the
linux-restricted-modules package. lrm-2.4.24 was shipped with Ubuntu
8.04 which reached end-of-life for desktop support on May 12th, 2011.

For that reason, this bug report is being closed at this time. I'm
marking it wontfix because what you describe is probably a valid issue,
but there are no plans to work on lrm 2.4.24 bugs further.

The issue may be resolved in a newer version. If not, aside from filing
a new bug report, another angle may be to file it directly with the
driver vendor.

Changed in linux-restricted-modules-2.6.24 (Ubuntu):
status: New → Won't Fix

What is the status on this bug? NVIDIA acknowledged an inefficency on their end which I believe they have applied since then but according to them, fixing firefox would greatly improve performance:
"Thanks for reporting this. I took a look today, and it appears that Firefox is using an enormous pixmap that exceeds the GPU's maximum rendering dimensions, causing software fallbacks. While we will attempt to make it as fast as possible, performance would be greatly improved if Firefox would render using surfaces that fit within the maximum renderable dimensions."
http://www.nvnews.net/vbulletin/showthread.php?t=152295&page=1

As someone else had mentioned before scrolling on this page is very slow: https://bugs.launchpad.net/ubuntu/+source/linux/+bug/550625?comments=all

Given the comments from the NVIDIA developer I zoomed out that page in firefox hoping it would 'fit within the maximum renderable dimensions" and indeed scrolling was smooth again.

The NVIDIA developer most be right if it works much better by zooming out plus I can see the system load spike very high when it 'defaults to software fallbacks'.

Tyler, thanks. That's very useful information!

Chances are, not much will happen here until we move to doing our own hardware-accelerated rendering on Linux, which will automatically mean pixmap sizes that the GPU can deal with...

Boris,
    Thanks for the update. Is there an estimated time line for the hardware-accelerated rendering on Linux? This has severely impacted our users experience with zimbra (full functionality is with ajax only) as well as pdf inline rendering, and I just need to know what we are looking at so I can provide appropriate work-arounds for my company.

Tyler, I'm not sure there's a firm timeline for it yet.... certainly order of months, not weeks, at best.

Hardware accelerated on Linux is already there - using cairo on top of xrender - which can be accelerated by hardware if the 2d driver supports it.

affects: firefox-3.0 (Ubuntu) → firefox (Ubuntu)
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.